/*
 * Copyright (c) 2003-2004 K. John '2B|!2B' Crispin
 * Copyright (c) 2005      Stephan Dobretsberger
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA02111-1307USA
 *
 * Feedback, Bugs, ... mail stephan.dobretsberger@gmx.at
 *
 */

#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>

#include "types.h"

// init SPI for ATmega8(L)
void spi_init(void)
{ sbi(DDRB,PB3);
  sbi(DDRB,PB5);
  cbi(DDRB,PB4);
  cbi(PORTB,PB4);
  outp((1<<MSTR)|(1<<SPE), SPCR);
};

// send and/or receive data
u08 spi_io(u08 data)
{ outp(data, SPDR);
  while((inp(SPSR)&(1<<SPIF)) == 0x00){};
  return inp(SPDR);
};
